/* Autogenerated file. Do not edit manually. */
/* tslint:disable */
/* eslint-disable */

import {
  Address,
  Contract,
  ContractState,
  TestContractResult,
  HexString,
  ContractFactory,
  EventSubscribeOptions,
  EventSubscription,
  CallContractParams,
  CallContractResult,
  TestContractParams,
  ContractEvent,
  subscribeContractEvent,
  subscribeContractEvents,
  testMethod,
  callMethod,
  multicallMethods,
  fetchContractState,
  ContractInstance,
  getContractEventsCurrentCount,
} from "@alephium/web3";
import { default as AlephlipContractJson } from "../Alephlip.ral.json";
import { getContractByCodeHash } from "./contracts";

// Custom types for the contract
export namespace AlephlipTypes {
  export type Fields = {
    poolFeesPercentage: bigint;
    devFeesPercentage: bigint;
    poolOwner: Address;
    devFeesBalance: bigint;
    poolBalance: bigint;
  };

  export type State = ContractState<Fields>;

  export type BetPlacedEvent = ContractEvent<{
    from: Address;
    betAmount: bigint;
  }>;
  export type BetResolvedEvent = ContractEvent<{
    from: Address;
    betAmount: bigint;
    isHeads: boolean;
    result: boolean;
  }>;
  export type SendPrizeEvent = ContractEvent<{ to: Address; prize: bigint }>;
  export type DestroyEvent = ContractEvent<{ from: Address }>;

  export interface CallMethodTable {
    play: {
      params: CallContractParams<{ isHeads: boolean; amount: bigint }>;
      result: CallContractResult<boolean>;
    };
    getPoolBalance: {
      params: Omit<CallContractParams<{}>, "args">;
      result: CallContractResult<bigint>;
    };
    getDevFeesBalance: {
      params: Omit<CallContractParams<{}>, "args">;
      result: CallContractResult<bigint>;
    };
    getFeesPercentage: {
      params: Omit<CallContractParams<{}>, "args">;
      result: CallContractResult<bigint>;
    };
  }
  export type CallMethodParams<T extends keyof CallMethodTable> =
    CallMethodTable[T]["params"];
  export type CallMethodResult<T extends keyof CallMethodTable> =
    CallMethodTable[T]["result"];
  export type MultiCallParams = Partial<{
    [Name in keyof CallMethodTable]: CallMethodTable[Name]["params"];
  }>;
  export type MultiCallResults<T extends MultiCallParams> = {
    [MaybeName in keyof T]: MaybeName extends keyof CallMethodTable
      ? CallMethodTable[MaybeName]["result"]
      : undefined;
  };
}

class Factory extends ContractFactory<AlephlipInstance, AlephlipTypes.Fields> {
  getInitialFieldsWithDefaultValues() {
    return this.contract.getInitialFieldsWithDefaultValues() as AlephlipTypes.Fields;
  }

  eventIndex = { BetPlaced: 0, BetResolved: 1, SendPrize: 2, Destroy: 3 };
  consts = {
    ErrorCodes: {
      BetAmountIsTooLow: BigInt(1),
      PoolBalanceIsTooLow: BigInt(2),
      InvalidCaller: BigInt(3),
      DevFeesPoolEmpty: BigInt(4),
      BetAmountIsTooHigh: BigInt(5),
    },
  };

  at(address: string): AlephlipInstance {
    return new AlephlipInstance(address);
  }

  tests = {
    random: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<bigint>> => {
      return testMethod(this, "random", params);
    },
    flip: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<boolean>> => {
      return testMethod(this, "flip", params);
    },
    placeBet: async (
      params: TestContractParams<AlephlipTypes.Fields, { amount: bigint }>
    ): Promise<TestContractResult<null>> => {
      return testMethod(this, "placeBet", params);
    },
    play: async (
      params: TestContractParams<
        AlephlipTypes.Fields,
        { isHeads: boolean; amount: bigint }
      >
    ): Promise<TestContractResult<boolean>> => {
      return testMethod(this, "play", params);
    },
    withdrawDevFees: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<null>> => {
      return testMethod(this, "withdrawDevFees", params);
    },
    ownerDeposit: async (
      params: TestContractParams<AlephlipTypes.Fields, { amount: bigint }>
    ): Promise<TestContractResult<null>> => {
      return testMethod(this, "ownerDeposit", params);
    },
    getPoolBalance: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<bigint>> => {
      return testMethod(this, "getPoolBalance", params);
    },
    getDevFeesBalance: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<bigint>> => {
      return testMethod(this, "getDevFeesBalance", params);
    },
    getFeesPercentage: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<bigint>> => {
      return testMethod(this, "getFeesPercentage", params);
    },
    destroyPool: async (
      params: Omit<TestContractParams<AlephlipTypes.Fields, never>, "testArgs">
    ): Promise<TestContractResult<null>> => {
      return testMethod(this, "destroyPool", params);
    },
  };
}

// Use this object to test and deploy the contract
export const Alephlip = new Factory(
  Contract.fromJson(
    AlephlipContractJson,
    "=4-2=3-1+4=2-2+39=2-2+88=2-2+e=1-1+4=1-1+fe=3-1+6=3-1+f=3-1+8=3-1+44147=11-1+f=16+0016007e0207726e6420697320=600",
    "33ddf54e08dde90b184387590dbeaafc702e0f3166a889a7a3cbfd0be3e7e145"
  )
);

// Use this class to interact with the blockchain
export class AlephlipInstance extends ContractInstance {
  constructor(address: Address) {
    super(address);
  }

  async fetchState(): Promise<AlephlipTypes.State> {
    return fetchContractState(Alephlip, this);
  }

  async getContractEventsCurrentCount(): Promise<number> {
    return getContractEventsCurrentCount(this.address);
  }

  subscribeBetPlacedEvent(
    options: EventSubscribeOptions<AlephlipTypes.BetPlacedEvent>,
    fromCount?: number
  ): EventSubscription {
    return subscribeContractEvent(
      Alephlip.contract,
      this,
      options,
      "BetPlaced",
      fromCount
    );
  }

  subscribeBetResolvedEvent(
    options: EventSubscribeOptions<AlephlipTypes.BetResolvedEvent>,
    fromCount?: number
  ): EventSubscription {
    return subscribeContractEvent(
      Alephlip.contract,
      this,
      options,
      "BetResolved",
      fromCount
    );
  }

  subscribeSendPrizeEvent(
    options: EventSubscribeOptions<AlephlipTypes.SendPrizeEvent>,
    fromCount?: number
  ): EventSubscription {
    return subscribeContractEvent(
      Alephlip.contract,
      this,
      options,
      "SendPrize",
      fromCount
    );
  }

  subscribeDestroyEvent(
    options: EventSubscribeOptions<AlephlipTypes.DestroyEvent>,
    fromCount?: number
  ): EventSubscription {
    return subscribeContractEvent(
      Alephlip.contract,
      this,
      options,
      "Destroy",
      fromCount
    );
  }

  subscribeAllEvents(
    options: EventSubscribeOptions<
      | AlephlipTypes.BetPlacedEvent
      | AlephlipTypes.BetResolvedEvent
      | AlephlipTypes.SendPrizeEvent
      | AlephlipTypes.DestroyEvent
    >,
    fromCount?: number
  ): EventSubscription {
    return subscribeContractEvents(Alephlip.contract, this, options, fromCount);
  }

  methods = {
    play: async (
      params: AlephlipTypes.CallMethodParams<"play">
    ): Promise<AlephlipTypes.CallMethodResult<"play">> => {
      return callMethod(Alephlip, this, "play", params, getContractByCodeHash);
    },
    getPoolBalance: async (
      params?: AlephlipTypes.CallMethodParams<"getPoolBalance">
    ): Promise<AlephlipTypes.CallMethodResult<"getPoolBalance">> => {
      return callMethod(
        Alephlip,
        this,
        "getPoolBalance",
        params === undefined ? {} : params,
        getContractByCodeHash
      );
    },
    getDevFeesBalance: async (
      params?: AlephlipTypes.CallMethodParams<"getDevFeesBalance">
    ): Promise<AlephlipTypes.CallMethodResult<"getDevFeesBalance">> => {
      return callMethod(
        Alephlip,
        this,
        "getDevFeesBalance",
        params === undefined ? {} : params,
        getContractByCodeHash
      );
    },
    getFeesPercentage: async (
      params?: AlephlipTypes.CallMethodParams<"getFeesPercentage">
    ): Promise<AlephlipTypes.CallMethodResult<"getFeesPercentage">> => {
      return callMethod(
        Alephlip,
        this,
        "getFeesPercentage",
        params === undefined ? {} : params,
        getContractByCodeHash
      );
    },
  };

  async multicall<Calls extends AlephlipTypes.MultiCallParams>(
    calls: Calls
  ): Promise<AlephlipTypes.MultiCallResults<Calls>> {
    return (await multicallMethods(
      Alephlip,
      this,
      calls,
      getContractByCodeHash
    )) as AlephlipTypes.MultiCallResults<Calls>;
  }
}
